Class: Aws::DevOpsAgent::Client

Inherits:
Seahorse::Client::Base show all
Includes:
ClientStubs
Defined in:
gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb

Overview

An API client for DevOpsAgent. To construct a client, you need to configure a :region and :credentials.

client = Aws::DevOpsAgent::Client.new(
  region: region_name,
  credentials: credentials,
  # ...
)

For details on configuring region and credentials see the developer guide.

See #initialize for a full list of supported configuration options.

Instance Attribute Summary

Attributes inherited from Seahorse::Client::Base

#config, #handlers

API Operations collapse

Instance Method Summary collapse

Methods included from ClientStubs

#api_requests, #stub_data, #stub_responses

Methods inherited from Seahorse::Client::Base

add_plugin, api, clear_plugins, define, new, #operation_names, plugins, remove_plugin, set_api, set_plugins

Methods included from Seahorse::Client::HandlerBuilder

#handle, #handle_request, #handle_response

Constructor Details

#initialize(options) ⇒ Client

Returns a new instance of Client.

Parameters:

  • options (Hash)

Options Hash (options):

  • :plugins (Array<Seahorse::Client::Plugin>) — default: []]

    A list of plugins to apply to the client. Each plugin is either a class name or an instance of a plugin class.

  • :credentials (required, Aws::CredentialProvider)

    Your AWS credentials used for authentication. This can be any class that includes and implements Aws::CredentialProvider, or instance of any one of the following classes:

    • Aws::Credentials - Used for configuring static, non-refreshing credentials.

    • Aws::SharedCredentials - Used for loading static credentials from a shared file, such as ~/.aws/config.

    • Aws::AssumeRoleCredentials - Used when you need to assume a role.

    • Aws::AssumeRoleWebIdentityCredentials - Used when you need to assume a role after providing credentials via the web.

    • Aws::SSOCredentials - Used for loading credentials from AWS SSO using an access token generated from aws login.

    • Aws::ProcessCredentials - Used for loading credentials from a process that outputs to stdout.

    • Aws::InstanceProfileCredentials - Used for loading credentials from an EC2 IMDS on an EC2 instance.

    • Aws::ECSCredentials - Used for loading credentials from instances running in ECS.

    • Aws::CognitoIdentityCredentials - Used for loading credentials from the Cognito Identity service.

    When :credentials are not configured directly, the following locations will be searched for credentials:

    • Aws.config[:credentials]

    • The :access_key_id, :secret_access_key, :session_token, and :account_id options.

    • ENV['AWS_ACCESS_KEY_ID'], ENV['AWS_SECRET_ACCESS_KEY'], ENV['AWS_SESSION_TOKEN'], and ENV['AWS_ACCOUNT_ID'].

    • ~/.aws/credentials

    • ~/.aws/config

    • EC2/ECS IMDS instance profile - When used by default, the timeouts are very aggressive. Construct and pass an instance of Aws::InstanceProfileCredentials or Aws::ECSCredentials to enable retries and extended timeouts. Instance profile credential fetching can be disabled by setting ENV['AWS_EC2_METADATA_DISABLED'] to true.

  • :region (required, String)

    The AWS region to connect to. The configured :region is used to determine the service :endpoint. When not passed, a default :region is searched for in the following locations:

    • Aws.config[:region]
    • ENV['AWS_REGION']
    • ENV['AMAZON_REGION']
    • ENV['AWS_DEFAULT_REGION']
    • ~/.aws/credentials
    • ~/.aws/config
  • :access_key_id (String)
  • :account_id (String)
  • :active_endpoint_cache (Boolean) — default: false

    When set to true, a thread polling for endpoints will be running in the background every 60 secs (default). Defaults to false.

  • :adaptive_retry_wait_to_fill (Boolean) — default: true

    Used only in adaptive retry mode. When true, the request will sleep until there is sufficent client side capacity to retry the request. When false, the request will raise a RetryCapacityNotAvailableError and will not retry instead of sleeping.

  • :auth_scheme_preference (Array<String>)

    A list of preferred authentication schemes to use when making a request. Supported values are: sigv4, sigv4a, httpBearerAuth, and noAuth. When set using ENV['AWS_AUTH_SCHEME_PREFERENCE'] or in shared config as auth_scheme_preference, the value should be a comma-separated list.

  • :client_side_monitoring (Boolean) — default: false

    When true, client-side metrics will be collected for all API requests from this client.

  • :client_side_monitoring_client_id (String) — default: ""

    Allows you to provide an identifier for this client which will be attached to all generated client side metrics. Defaults to an empty string.

  • :client_side_monitoring_host (String) — default: "127.0.0.1"

    Allows you to specify the DNS hostname or IPv4 or IPv6 address that the client side monitoring agent is running on, where client metrics will be published via UDP.

  • :client_side_monitoring_port (Integer) — default: 31000

    Required for publishing client metrics. The port that the client side monitoring agent is running on, where client metrics will be published via UDP.

  • :client_side_monitoring_publisher (Aws::ClientSideMonitoring::Publisher) — default: Aws::ClientSideMonitoring::Publisher

    Allows you to provide a custom client-side monitoring publisher class. By default, will use the Client Side Monitoring Agent Publisher.

  • :convert_params (Boolean) — default: true

    When true, an attempt is made to coerce request parameters into the required types.

  • :correct_clock_skew (Boolean) — default: true

    Used only in standard and adaptive retry modes. Specifies whether to apply a clock skew correction and retry requests with skewed client clocks.

  • :defaults_mode (String) — default: "legacy"

    See Aws::DefaultsModeConfiguration for a list of the accepted modes and the configuration defaults that are included.

  • :disable_host_prefix_injection (Boolean) — default: false

    When true, the SDK will not prepend the modeled host prefix to the endpoint.

  • :disable_request_compression (Boolean) — default: false

    When set to 'true' the request body will not be compressed for supported operations.

  • :endpoint (String, URI::HTTPS, URI::HTTP)

    Normally you should not configure the :endpoint option directly. This is normally constructed from the :region option. Configuring :endpoint is normally reserved for connecting to test or custom endpoints. The endpoint should be a URI formatted like:

    'http://example.com'
    'https://example.com'
    'http://example.com:123'
    
  • :endpoint_cache_max_entries (Integer) — default: 1000

    Used for the maximum size limit of the LRU cache storing endpoints data for endpoint discovery enabled operations. Defaults to 1000.

  • :endpoint_cache_max_threads (Integer) — default: 10

    Used for the maximum threads in use for polling endpoints to be cached, defaults to 10.

  • :endpoint_cache_poll_interval (Integer) — default: 60

    When :endpoint_discovery and :active_endpoint_cache is enabled, Use this option to config the time interval in seconds for making requests fetching endpoints information. Defaults to 60 sec.

  • :endpoint_discovery (Boolean) — default: false

    When set to true, endpoint discovery will be enabled for operations when available.

  • :event_stream_handler (Proc)

    When an EventStream or Proc object is provided, it will be used as callback for each chunk of event stream response received along the way.

  • :ignore_configured_endpoint_urls (Boolean)

    Setting to true disables use of endpoint URLs provided via environment variables and the shared configuration file.

  • :input_event_stream_handler (Proc)

    When an EventStream or Proc object is provided, it can be used for sending events for the event stream.

  • :log_formatter (Aws::Log::Formatter) — default: Aws::Log::Formatter.default

    The log formatter.

  • :log_level (Symbol) — default: :info

    The log level to send messages to the :logger at.

  • :logger (Logger)

    The Logger instance to send log messages to. If this option is not set, logging will be disabled.

  • :max_attempts (Integer) — default: 3

    An integer representing the maximum number attempts that will be made for a single request, including the initial attempt. For example, setting this value to 5 will result in a request being retried up to 4 times. Used in standard and adaptive retry modes.

  • :output_event_stream_handler (Proc)

    When an EventStream or Proc object is provided, it will be used as callback for each chunk of event stream response received along the way.

  • :profile (String) — default: "default"

    Used when loading credentials from the shared credentials file at HOME/.aws/credentials. When not specified, 'default' is used.

  • :request_checksum_calculation (String) — default: "when_supported"

    Determines when a checksum will be calculated for request payloads. Values are:

    • when_supported - (default) When set, a checksum will be calculated for all request payloads of operations modeled with the httpChecksum trait where requestChecksumRequired is true and/or a requestAlgorithmMember is modeled.
    • when_required - When set, a checksum will only be calculated for request payloads of operations modeled with the httpChecksum trait where requestChecksumRequired is true or where a requestAlgorithmMember is modeled and supplied.
  • :request_min_compression_size_bytes (Integer) — default: 10240

    The minimum size in bytes that triggers compression for request bodies. The value must be non-negative integer value between 0 and 10485780 bytes inclusive.

  • :response_checksum_validation (String) — default: "when_supported"

    Determines when checksum validation will be performed on response payloads. Values are:

    • when_supported - (default) When set, checksum validation is performed on all response payloads of operations modeled with the httpChecksum trait where responseAlgorithms is modeled, except when no modeled checksum algorithms are supported.
    • when_required - When set, checksum validation is not performed on response payloads of operations unless the checksum algorithm is supported and the requestValidationModeMember member is set to ENABLED.
  • :retry_backoff (Proc)

    A proc or lambda used for backoff. Defaults to 2**retries * retry_base_delay. This option is only used in the legacy retry mode.

  • :retry_base_delay (Float) — default: 0.3

    The base delay in seconds used by the default backoff function. This option is only used in the legacy retry mode.

  • :retry_jitter (Symbol) — default: :none

    A delay randomiser function used by the default backoff function. Some predefined functions can be referenced by name - :none, :equal, :full, otherwise a Proc that takes and returns a number. This option is only used in the legacy retry mode.

    @see https://www.awsarchitectureblog.com/2015/03/backoff.html

  • :retry_limit (Integer) — default: 3

    The maximum number of times to retry failed requests. Only ~ 500 level server errors and certain ~ 400 level client errors are retried. Generally, these are throttling errors, data checksum errors, networking errors, timeout errors, auth errors, endpoint discovery, and errors from expired credentials. This option is only used in the legacy retry mode.

  • :retry_max_delay (Integer) — default: 0

    The maximum number of seconds to delay between retries (0 for no limit) used by the default backoff function. This option is only used in the legacy retry mode.

  • :retry_mode (String) — default: "legacy"

    Specifies which retry algorithm to use. Values are:

    • legacy - The pre-existing retry behavior. This is default value if no retry mode is provided.

    • standard - A standardized set of retry rules across the AWS SDKs. This includes support for retry quotas, which limit the number of unsuccessful retries a client can make.

    • adaptive - An experimental retry mode that includes all the functionality of standard mode along with automatic client side throttling. This is a provisional mode that may change behavior in the future.

  • :sdk_ua_app_id (String)

    A unique and opaque application ID that is appended to the User-Agent header as app/sdk_ua_app_id. It should have a maximum length of 50. This variable is sourced from environment variable AWS_SDK_UA_APP_ID or the shared config profile attribute sdk_ua_app_id.

  • :secret_access_key (String)
  • :session_token (String)
  • :sigv4a_signing_region_set (Array)

    A list of regions that should be signed with SigV4a signing. When not passed, a default :sigv4a_signing_region_set is searched for in the following locations:

    • Aws.config[:sigv4a_signing_region_set]
    • ENV['AWS_SIGV4A_SIGNING_REGION_SET']
    • ~/.aws/config
  • :stub_responses (Boolean) — default: false

    Causes the client to return stubbed responses. By default fake responses are generated and returned. You can specify the response data to return or errors to raise by calling ClientStubs#stub_responses. See ClientStubs for more information.

    Please note When response stubbing is enabled, no HTTP requests are made, and retries are disabled.

  • :telemetry_provider (Aws::Telemetry::TelemetryProviderBase) — default: Aws::Telemetry::NoOpTelemetryProvider

    Allows you to provide a telemetry provider, which is used to emit telemetry data. By default, uses NoOpTelemetryProvider which will not record or emit any telemetry data. The SDK supports the following telemetry providers:

    • OpenTelemetry (OTel) - To use the OTel provider, install and require the opentelemetry-sdk gem and then, pass in an instance of a Aws::Telemetry::OTelProvider for telemetry provider.
  • :token_provider (Aws::TokenProvider)

    Your Bearer token used for authentication. This can be any class that includes and implements Aws::TokenProvider, or instance of any one of the following classes:

    • Aws::StaticTokenProvider - Used for configuring static, non-refreshing tokens.

    • Aws::SSOTokenProvider - Used for loading tokens from AWS SSO using an access token generated from aws login.

    When :token_provider is not configured directly, the Aws::TokenProviderChain will be used to search for tokens configured for your profile in shared configuration files.

  • :use_dualstack_endpoint (Boolean)

    When set to true, dualstack enabled endpoints (with .aws TLD) will be used if available.

  • :use_fips_endpoint (Boolean)

    When set to true, fips compatible endpoints will be used if available. When a fips region is used, the region is normalized and this config is set to true.

  • :validate_params (Boolean) — default: true

    When true, request parameters are validated before sending the request.

  • :endpoint_provider (Aws::DevOpsAgent::EndpointProvider)

    The endpoint provider used to resolve endpoints. Any object that responds to #resolve_endpoint(parameters) where parameters is a Struct similar to Aws::DevOpsAgent::EndpointParameters.

  • :http_continue_timeout (Float) — default: 1

    The number of seconds to wait for a 100-continue response before sending the request body. This option has no effect unless the request has "Expect" header set to "100-continue". Defaults to nil which disables this behaviour. This value can safely be set per request on the session.

  • :http_idle_timeout (Float) — default: 5

    The number of seconds a connection is allowed to sit idle before it is considered stale. Stale connections are closed and removed from the pool before making a request.

  • :http_open_timeout (Float) — default: 15

    The default number of seconds to wait for response data. This value can safely be set per-request on the session.

  • :http_proxy (URI::HTTP, String)

    A proxy to send requests through. Formatted like 'http://proxy.com:123'.

  • :http_read_timeout (Float) — default: 60

    The default number of seconds to wait for response data. This value can safely be set per-request on the session.

  • :http_wire_trace (Boolean) — default: false

    When true, HTTP debug output will be sent to the :logger.

  • :on_chunk_received (Proc)

    When a Proc object is provided, it will be used as callback when each chunk of the response body is received. It provides three arguments: the chunk, the number of bytes received, and the total number of bytes in the response (or nil if the server did not send a content-length).

  • :on_chunk_sent (Proc)

    When a Proc object is provided, it will be used as callback when each chunk of the request body is sent. It provides three arguments: the chunk, the number of bytes read from the body, and the total number of bytes in the body.

  • :raise_response_errors (Boolean) — default: true

    When true, response errors are raised.

  • :ssl_ca_bundle (String)

    Full path to the SSL certificate authority bundle file that should be used when verifying peer certificates. If you do not pass :ssl_ca_bundle or :ssl_ca_directory the the system default will be used if available.

  • :ssl_ca_directory (String)

    Full path of the directory that contains the unbundled SSL certificate authority files for verifying peer certificates. If you do not pass :ssl_ca_bundle or :ssl_ca_directory the the system default will be used if available.

  • :ssl_ca_store (String)

    Sets the X509::Store to verify peer certificate.

  • :ssl_cert (OpenSSL::X509::Certificate)

    Sets a client certificate when creating http connections.

  • :ssl_key (OpenSSL::PKey)

    Sets a client key when creating http connections.

  • :ssl_timeout (Float)

    Sets the SSL timeout in seconds

  • :ssl_verify_peer (Boolean) — default: true

    When true, SSL peer certificates are verified when establishing a connection.



484
485
486
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 484

def initialize(*args)
  super
end

Instance Method Details

#allow_vended_log_delivery_for_resource(params = {}) ⇒ Types::AllowVendedLogDeliveryForResourceOutput

Authorize Ingestion Hub subscription operation.

Examples:

Request syntax with placeholder values


resp = client.allow_vended_log_delivery_for_resource({
  resource_arn_being_authorized: "String", # required
  delivery_source_arn: "AllowVendedLogDeliveryForResourceInputDeliverySourceArnString", # required
  log_type: "String",
})

Response structure


resp.message #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :resource_arn_being_authorized (required, String)

    The ARN of the resource being authorized for vended log delivery.

  • :delivery_source_arn (required, String)

    The ARN of the delivery source for vended log delivery.

  • :log_type (String)

    The type of log to be delivered.

Returns:

See Also:



521
522
523
524
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 521

def allow_vended_log_delivery_for_resource(params = {}, options = {})
  req = build_request(:allow_vended_log_delivery_for_resource, params)
  req.send_request(options)
end

#associate_service(params = {}) ⇒ Types::AssociateServiceOutput

Adds a specific service association to an AgentSpace. It overwrites the existing association of the same service. Returns 201 Created on success.

Examples:

Request syntax with placeholder values


resp = client.associate_service({
  agent_space_id: "AgentSpaceId", # required
  service_id: "ServiceId", # required
  configuration: { # required
    source_aws: {
      account_id: "SourceAwsConfigurationAccountIdString", # required
      account_type: "source", # required, accepts source
      assumable_role_arn: "RoleArn", # required
      external_id: "String",
    },
    aws: {
      assumable_role_arn: "RoleArn", # required
      account_id: "AWSConfigurationAccountIdString", # required
      account_type: "monitor", # required, accepts monitor
    },
    github: {
      repo_name: "String", # required
      repo_id: "String", # required
      owner: "String", # required
      owner_type: "organization", # required, accepts organization, user
      instance_identifier: "String",
    },
    slack: {
      workspace_id: "SlackConfigurationWorkspaceIdString", # required
      workspace_name: "String", # required
      transmission_target: { # required
        ops_oncall_target: { # required
          channel_name: "String",
          channel_id: "SlackChannelChannelIdString", # required
        },
        ops_sre_target: {
          channel_name: "String",
          channel_id: "SlackChannelChannelIdString", # required
        },
      },
    },
    dynatrace: {
      env_id: "String", # required
      resources: ["String"],
    },
    servicenow: {
      instance_id: "String",
      auth_scopes: ["String"],
    },
    mcpservernewrelic: {
      account_id: "MCPServerNewRelicConfigurationAccountIdString", # required
      endpoint: "MCPServerNewRelicConfigurationEndpointString", # required
    },
    gitlab: {
      project_id: "String", # required
      project_path: "String", # required
      instance_identifier: "String",
    },
    event_channel: {
    },
    azure: {
      subscription_id: "String", # required
    },
    azuredevops: {
      organization_name: "String", # required
      project_id: "String", # required
      project_name: "String", # required
    },
    mcpservergrafana: {
      endpoint: "MCPServerGrafanaConfigurationEndpointString", # required
      organization_id: "MCPServerGrafanaConfigurationOrganizationIdString",
      tools: ["MCPToolsListMemberString"],
    },
    pagerduty: {
      services: ["String"], # required
      customer_email: "EmailAddress", # required
    },
  },
})

Response structure


resp.association.agent_space_id #=> String
resp.association.created_at #=> Time
resp.association.updated_at #=> Time
resp.association.status #=> String, one of "valid", "invalid", "pending-confirmation"
resp.association.association_id #=> String
resp.association.service_id #=> String
resp.association.configuration.source_aws. #=> String
resp.association.configuration.source_aws. #=> String, one of "source"
resp.association.configuration.source_aws.assumable_role_arn #=> String
resp.association.configuration.source_aws.external_id #=> String
resp.association.configuration.aws.assumable_role_arn #=> String
resp.association.configuration.aws. #=> String
resp.association.configuration.aws. #=> String, one of "monitor"
resp.association.configuration.github.repo_name #=> String
resp.association.configuration.github.repo_id #=> String
resp.association.configuration.github.owner #=> String
resp.association.configuration.github.owner_type #=> String, one of "organization", "user"
resp.association.configuration.github.instance_identifier #=> String
resp.association.configuration.slack.workspace_id #=> String
resp.association.configuration.slack.workspace_name #=> String
resp.association.configuration.slack.transmission_target.ops_oncall_target.channel_name #=> String
resp.association.configuration.slack.transmission_target.ops_oncall_target.channel_id #=> String
resp.association.configuration.slack.transmission_target.ops_sre_target.channel_name #=> String
resp.association.configuration.slack.transmission_target.ops_sre_target.channel_id #=> String
resp.association.configuration.dynatrace.env_id #=> String
resp.association.configuration.dynatrace.resources #=> Array
resp.association.configuration.dynatrace.resources[0] #=> String
resp.association.configuration.servicenow.instance_id #=> String
resp.association.configuration.servicenow.auth_scopes #=> Array
resp.association.configuration.servicenow.auth_scopes[0] #=> String
resp.association.configuration.mcpservernewrelic. #=> String
resp.association.configuration.mcpservernewrelic.endpoint #=> String
resp.association.configuration.gitlab.project_id #=> String
resp.association.configuration.gitlab.project_path #=> String
resp.association.configuration.gitlab.instance_identifier #=> String
resp.association.configuration.azure.subscription_id #=> String
resp.association.configuration.azuredevops.organization_name #=> String
resp.association.configuration.azuredevops.project_id #=> String
resp.association.configuration.azuredevops.project_name #=> String
resp.association.configuration.mcpservergrafana.endpoint #=> String
resp.association.configuration.mcpservergrafana.organization_id #=> String
resp.association.configuration.mcpservergrafana.tools #=> Array
resp.association.configuration.mcpservergrafana.tools[0] #=> String
resp.association.configuration.pagerduty.services #=> Array
resp.association.configuration.pagerduty.services[0] #=> String
resp.association.configuration.pagerduty.customer_email #=> String
resp.webhook.webhook_url #=> String
resp.webhook.webhook_id #=> String
resp.webhook.webhook_type #=> String, one of "hmac", "apikey", "gitlab", "pagerduty"
resp.webhook.webhook_secret #=> String
resp.webhook.api_key #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :service_id (required, String)

    The unique identifier of the service.

  • :configuration (required, Types::ServiceConfiguration)

    The configuration that directs how AgentSpace interacts with the given service.

Returns:

See Also:



680
681
682
683
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 680

def associate_service(params = {}, options = {})
  req = build_request(:associate_service, params)
  req.send_request(options)
end

#create_agent_space(params = {}) ⇒ Types::CreateAgentSpaceOutput

Creates a new AgentSpace with the specified name and description. Duplicate space names are allowed.

Examples:

Request syntax with placeholder values


resp = client.create_agent_space({
  name: "AgentSpaceName", # required
  description: "Description",
  locale: "Locale",
  kms_key_arn: "KmsKeyArn",
  client_token: "CreateAgentSpaceInputClientTokenString",
  tags: {
    "TagKey" => "TagValue",
  },
})

Response structure


resp.agent_space.name #=> String
resp.agent_space.description #=> String
resp.agent_space.locale #=> String
resp.agent_space.created_at #=> Time
resp.agent_space.updated_at #=> Time
resp.agent_space.kms_key_arn #=> String
resp.agent_space.agent_space_id #=> String
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :name (required, String)

    The name of the AgentSpace.

  • :description (String)

    The description of the AgentSpace.

  • :locale (String)

    The locale for the AgentSpace, which determines the language used in agent responses.

  • :kms_key_arn (String)

    The ARN of the AWS Key Management Service (AWS KMS) customer managed key that's used to encrypt resources.

  • :client_token (String)

    Client-provided token to ensure request idempotency. When the same token is provided in subsequent calls, the same response is returned within a 8-hour window.

    A suitable default value is auto-generated. You should normally not need to pass this option.**

  • :tags (Hash<String,String>)

    Tags to add to the AgentSpace at creation time.

Returns:

See Also:



747
748
749
750
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 747

def create_agent_space(params = {}, options = {})
  req = build_request(:create_agent_space, params)
  req.send_request(options)
end

#create_backlog_task(params = {}) ⇒ Types::CreateBacklogTaskResponse

Creates a new backlog task in the specified agent space

Examples:

Request syntax with placeholder values


resp = client.create_backlog_task({
  agent_space_id: "AgentSpaceId", # required
  reference: {
    system: "ReferenceInputSystemString", # required
    title: "ReferenceInputTitleString",
    reference_id: "ResourceId", # required
    reference_url: "ReferenceInputReferenceUrlString", # required
    association_id: "ResourceId", # required
  },
  task_type: "INVESTIGATION", # required, accepts INVESTIGATION, EVALUATION
  title: "BacklogTaskTitle", # required
  description: "BacklogTaskDescription",
  priority: "CRITICAL", # required, accepts CRITICAL, HIGH, MEDIUM, LOW, MINIMAL
  client_token: "String",
})

Response structure


resp.task.agent_space_id #=> String
resp.task.task_id #=> String
resp.task.execution_id #=> String
resp.task.title #=> String
resp.task.description #=> String
resp.task.reference.system #=> String
resp.task.reference.title #=> String
resp.task.reference.reference_id #=> String
resp.task.reference.reference_url #=> String
resp.task.reference.association_id #=> String
resp.task.task_type #=> String, one of "INVESTIGATION", "EVALUATION"
resp.task.priority #=> String, one of "CRITICAL", "HIGH", "MEDIUM", "LOW", "MINIMAL"
resp.task.status #=> String, one of "PENDING_TRIAGE", "LINKED", "PENDING_START", "IN_PROGRESS", "PENDING_CUSTOMER_APPROVAL", "COMPLETED", "FAILED", "TIMED_OUT", "CANCELED"
resp.task.created_at #=> Time
resp.task.updated_at #=> Time
resp.task.version #=> Integer
resp.task.primary_task_id #=> String
resp.task.status_reason #=> String
resp.task.has_linked_tasks #=> Boolean

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space where the task will be created

  • :reference (Types::ReferenceInput)

    Optional reference information for the task

  • :task_type (required, String)

    The type of task being created

  • :title (required, String)

    The title of the backlog task

  • :description (String)

    Optional detailed description of the task

  • :priority (required, String)

    The priority level of the task

  • :client_token (String)

    Client-provided token for idempotent operations

    A suitable default value is auto-generated. You should normally not need to pass this option.**

Returns:

See Also:



827
828
829
830
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 827

def create_backlog_task(params = {}, options = {})
  req = build_request(:create_backlog_task, params)
  req.send_request(options)
end

#create_chat(params = {}) ⇒ Types::CreateChatResponse

Creates a new chat execution in the specified agent space

Examples:

Request syntax with placeholder values


resp = client.create_chat({
  agent_space_id: "AgentSpaceId", # required
  user_id: "ResourceId", # required
  user_type: "IAM", # accepts IAM, IDC, IDP
})

Response structure


resp.execution_id #=> String
resp.created_at #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    Unique identifier for an agent space (allows alphanumeric characters and hyphens; 1-64 characters)

  • :user_id (required, String)

    The user identifier for the chat

  • :user_type (String)

    The authentication type of the user

Returns:

See Also:



866
867
868
869
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 866

def create_chat(params = {}, options = {})
  req = build_request(:create_chat, params)
  req.send_request(options)
end

#create_private_connection(params = {}) ⇒ Types::CreatePrivateConnectionOutput

Creates a Private Connection to a target resource.

Examples:

Request syntax with placeholder values


resp = client.create_private_connection({
  name: "PrivateConnectionName", # required
  mode: { # required
    service_managed: {
      host_address: "IpAddressOrDnsName", # required
      vpc_id: "VpcId", # required
      subnet_ids: ["SubnetId"], # required
      security_group_ids: ["SecurityGroupId"],
      ip_address_type: "IPV4", # accepts IPV4, IPV6, DUAL_STACK
      ipv4_addresses_per_eni: 1,
      port_ranges: ["PortRange"],
      certificate: "CertificateString",
    },
    self_managed: {
      resource_configuration_id: "ResourceConfigurationArn", # required
      certificate: "CertificateString",
    },
  },
  tags: {
    "TagKey" => "TagValue",
  },
})

Response structure


resp.name #=> String
resp.type #=> String, one of "SELF_MANAGED", "SERVICE_MANAGED"
resp.resource_gateway_id #=> String
resp.host_address #=> String
resp.vpc_id #=> String
resp.resource_configuration_id #=> String
resp.status #=> String, one of "ACTIVE", "CREATE_IN_PROGRESS", "CREATE_FAILED", "DELETE_IN_PROGRESS", "DELETE_FAILED"
resp.certificate_expiry_time #=> Time
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :name (required, String)

    Unique name for this Private Connection within the account.

  • :mode (required, Types::PrivateConnectionMode)

    Private Connection mode configuration.

  • :tags (Hash<String,String>)

    Tags to add to the Private Connection at creation time.

Returns:

See Also:



936
937
938
939
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 936

def create_private_connection(params = {}, options = {})
  req = build_request(:create_private_connection, params)
  req.send_request(options)
end

#delete_agent_space(params = {}) ⇒ Struct

Deletes an AgentSpace. This operation is idempotent and returns a 204 No Content response on success.

Examples:

Request syntax with placeholder values


resp = client.delete_agent_space({
  agent_space_id: "AgentSpaceId", # required
})

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

Returns:

  • (Struct)

    Returns an empty response.

See Also:



959
960
961
962
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 959

def delete_agent_space(params = {}, options = {})
  req = build_request(:delete_agent_space, params)
  req.send_request(options)
end

#delete_private_connection(params = {}) ⇒ Types::DeletePrivateConnectionOutput

Deletes a Private Connection. The deletion is asynchronous and returns DELETE_IN_PROGRESS status.

Examples:

Request syntax with placeholder values


resp = client.delete_private_connection({
  name: "PrivateConnectionName", # required
})

Response structure


resp.name #=> String
resp.status #=> String, one of "ACTIVE", "CREATE_IN_PROGRESS", "CREATE_FAILED", "DELETE_IN_PROGRESS", "DELETE_FAILED"

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :name (required, String)

    The name of the Private Connection.

Returns:

See Also:



990
991
992
993
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 990

def delete_private_connection(params = {}, options = {})
  req = build_request(:delete_private_connection, params)
  req.send_request(options)
end

#deregister_service(params = {}) ⇒ Struct

Deregister a service

Examples:

Request syntax with placeholder values


resp = client.deregister_service({
  service_id: "ServiceId", # required
})

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :service_id (required, String)

    The service id to deregister. A service can only be deregistered if it is not associated with any AgentSpace.

Returns:

  • (Struct)

    Returns an empty response.

See Also:



1013
1014
1015
1016
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1013

def deregister_service(params = {}, options = {})
  req = build_request(:deregister_service, params)
  req.send_request(options)
end

#describe_private_connection(params = {}) ⇒ Types::DescribePrivateConnectionOutput

Retrieves details of an existing Private Connection.

Examples:

Request syntax with placeholder values


resp = client.describe_private_connection({
  name: "PrivateConnectionName", # required
})

Response structure


resp.name #=> String
resp.type #=> String, one of "SELF_MANAGED", "SERVICE_MANAGED"
resp.resource_gateway_id #=> String
resp.host_address #=> String
resp.vpc_id #=> String
resp.resource_configuration_id #=> String
resp.status #=> String, one of "ACTIVE", "CREATE_IN_PROGRESS", "CREATE_FAILED", "DELETE_IN_PROGRESS", "DELETE_FAILED"
resp.certificate_expiry_time #=> Time
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :name (required, String)

    The name of the Private Connection.

Returns:

See Also:



1058
1059
1060
1061
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1058

def describe_private_connection(params = {}, options = {})
  req = build_request(:describe_private_connection, params)
  req.send_request(options)
end

#disable_operator_app(params = {}) ⇒ Struct

Disable the Operator App for the specified AgentSpace

Examples:

Request syntax with placeholder values


resp = client.disable_operator_app({
  agent_space_id: "AgentSpaceId", # required
  auth_flow: "iam", # accepts iam, idc, idp
})

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :auth_flow (String)

    The authentication flow configured for the operator App. e.g. idc

Returns:

  • (Struct)

    Returns an empty response.

See Also:



1084
1085
1086
1087
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1084

def disable_operator_app(params = {}, options = {})
  req = build_request(:disable_operator_app, params)
  req.send_request(options)
end

#disassociate_service(params = {}) ⇒ Struct

Deletes a specific service association from an AgentSpace. This operation is idempotent and returns a 204 No Content response on success.

Examples:

Request syntax with placeholder values


resp = client.disassociate_service({
  agent_space_id: "AgentSpaceId", # required
  association_id: "AssociationId", # required
})

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :association_id (required, String)

    The unique identifier of the given association.

Returns:

  • (Struct)

    Returns an empty response.

See Also:



1112
1113
1114
1115
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1112

def disassociate_service(params = {}, options = {})
  req = build_request(:disassociate_service, params)
  req.send_request(options)
end

#enable_operator_app(params = {}) ⇒ Types::EnableOperatorAppOutput

Enable the Operator App to access the given AgentSpace

Examples:

Request syntax with placeholder values


resp = client.enable_operator_app({
  agent_space_id: "AgentSpaceId", # required
  auth_flow: "iam", # required, accepts iam, idc, idp
  operator_app_role_arn: "RoleArn", # required
  idc_instance_arn: "String",
  issuer_url: "String",
  idp_client_id: "IdpClientId",
  idp_client_secret: "IdpClientSecret",
  provider: "String",
})

Response structure


resp.agent_space_id #=> String
resp.iam.operator_app_role_arn #=> String
resp.iam.created_at #=> Time
resp.iam.updated_at #=> Time
resp.idc.operator_app_role_arn #=> String
resp.idc.idc_instance_arn #=> String
resp.idc.idc_application_arn #=> String
resp.idc.created_at #=> Time
resp.idc.updated_at #=> Time
resp.idp.issuer_url #=> String
resp.idp.client_id #=> String
resp.idp.operator_app_role_arn #=> String
resp.idp.provider #=> String
resp.idp.created_at #=> Time
resp.idp.updated_at #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :auth_flow (required, String)

    The authentication flow configured for the operator App. e.g. iam or idc

  • :operator_app_role_arn (required, String)

    The IAM role end users assume to access AIDevOps APIs

  • :idc_instance_arn (String)

    The IdC instance Arn used to create an IdC auth application

  • :issuer_url (String)

    The OIDC issuer URL of the external Identity Provider

  • :idp_client_id (String)

    The OIDC client ID for the IdP application

  • :idp_client_secret (String)

    The OIDC client secret for the IdP application

  • :provider (String)

    The Identity Provider name (e.g., Entra, Okta, Google)

Returns:

See Also:



1186
1187
1188
1189
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1186

def enable_operator_app(params = {}, options = {})
  req = build_request(:enable_operator_app, params)
  req.send_request(options)
end

#get_account_usage(params = {}) ⇒ Types::GetAccountUsageOutput

Retrieves monthly account usage metrics and limits for the AWS account.

Examples:

Response structure


resp..limit #=> Integer
resp..usage #=> Float
resp..limit #=> Integer
resp..usage #=> Float
resp..limit #=> Integer
resp..usage #=> Float
resp..limit #=> Integer
resp..usage #=> Float
resp.usage_period_start_time #=> Time
resp.usage_period_end_time #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Returns:

See Also:



1220
1221
1222
1223
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1220

def (params = {}, options = {})
  req = build_request(:get_account_usage, params)
  req.send_request(options)
end

#get_agent_space(params = {}) ⇒ Types::GetAgentSpaceOutput

Retrieves detailed information about a specific AgentSpace.

Examples:

Request syntax with placeholder values


resp = client.get_agent_space({
  agent_space_id: "AgentSpaceId", # required
})

Response structure


resp.agent_space.name #=> String
resp.agent_space.description #=> String
resp.agent_space.locale #=> String
resp.agent_space.created_at #=> Time
resp.agent_space.updated_at #=> Time
resp.agent_space.kms_key_arn #=> String
resp.agent_space.agent_space_id #=> String
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

Returns:

See Also:



1257
1258
1259
1260
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1257

def get_agent_space(params = {}, options = {})
  req = build_request(:get_agent_space, params)
  req.send_request(options)
end

#get_association(params = {}) ⇒ Types::GetAssociationOutput

Retrieves given associations configured for a specific AgentSpace.

Examples:

Request syntax with placeholder values


resp = client.get_association({
  agent_space_id: "AgentSpaceId", # required
  association_id: "AssociationId", # required
})

Response structure


resp.association.agent_space_id #=> String
resp.association.created_at #=> Time
resp.association.updated_at #=> Time
resp.association.status #=> String, one of "valid", "invalid", "pending-confirmation"
resp.association.association_id #=> String
resp.association.service_id #=> String
resp.association.configuration.source_aws. #=> String
resp.association.configuration.source_aws. #=> String, one of "source"
resp.association.configuration.source_aws.assumable_role_arn #=> String
resp.association.configuration.source_aws.external_id #=> String
resp.association.configuration.aws.assumable_role_arn #=> String
resp.association.configuration.aws. #=> String
resp.association.configuration.aws. #=> String, one of "monitor"
resp.association.configuration.github.repo_name #=> String
resp.association.configuration.github.repo_id #=> String
resp.association.configuration.github.owner #=> String
resp.association.configuration.github.owner_type #=> String, one of "organization", "user"
resp.association.configuration.github.instance_identifier #=> String
resp.association.configuration.slack.workspace_id #=> String
resp.association.configuration.slack.workspace_name #=> String
resp.association.configuration.slack.transmission_target.ops_oncall_target.channel_name #=> String
resp.association.configuration.slack.transmission_target.ops_oncall_target.channel_id #=> String
resp.association.configuration.slack.transmission_target.ops_sre_target.channel_name #=> String
resp.association.configuration.slack.transmission_target.ops_sre_target.channel_id #=> String
resp.association.configuration.dynatrace.env_id #=> String
resp.association.configuration.dynatrace.resources #=> Array
resp.association.configuration.dynatrace.resources[0] #=> String
resp.association.configuration.servicenow.instance_id #=> String
resp.association.configuration.servicenow.auth_scopes #=> Array
resp.association.configuration.servicenow.auth_scopes[0] #=> String
resp.association.configuration.mcpservernewrelic. #=> String
resp.association.configuration.mcpservernewrelic.endpoint #=> String
resp.association.configuration.gitlab.project_id #=> String
resp.association.configuration.gitlab.project_path #=> String
resp.association.configuration.gitlab.instance_identifier #=> String
resp.association.configuration.azure.subscription_id #=> String
resp.association.configuration.azuredevops.organization_name #=> String
resp.association.configuration.azuredevops.project_id #=> String
resp.association.configuration.azuredevops.project_name #=> String
resp.association.configuration.mcpservergrafana.endpoint #=> String
resp.association.configuration.mcpservergrafana.organization_id #=> String
resp.association.configuration.mcpservergrafana.tools #=> Array
resp.association.configuration.mcpservergrafana.tools[0] #=> String
resp.association.configuration.pagerduty.services #=> Array
resp.association.configuration.pagerduty.services[0] #=> String
resp.association.configuration.pagerduty.customer_email #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :association_id (required, String)

    The unique identifier of the given association.

Returns:

See Also:



1334
1335
1336
1337
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1334

def get_association(params = {}, options = {})
  req = build_request(:get_association, params)
  req.send_request(options)
end

#get_backlog_task(params = {}) ⇒ Types::GetBacklogTaskResponse

Gets a backlog task for the specified agent space and task id

Examples:

Request syntax with placeholder values


resp = client.get_backlog_task({
  agent_space_id: "AgentSpaceId", # required
  task_id: "ResourceId", # required
})

Response structure


resp.task.agent_space_id #=> String
resp.task.task_id #=> String
resp.task.execution_id #=> String
resp.task.title #=> String
resp.task.description #=> String
resp.task.reference.system #=> String
resp.task.reference.title #=> String
resp.task.reference.reference_id #=> String
resp.task.reference.reference_url #=> String
resp.task.reference.association_id #=> String
resp.task.task_type #=> String, one of "INVESTIGATION", "EVALUATION"
resp.task.priority #=> String, one of "CRITICAL", "HIGH", "MEDIUM", "LOW", "MINIMAL"
resp.task.status #=> String, one of "PENDING_TRIAGE", "LINKED", "PENDING_START", "IN_PROGRESS", "PENDING_CUSTOMER_APPROVAL", "COMPLETED", "FAILED", "TIMED_OUT", "CANCELED"
resp.task.created_at #=> Time
resp.task.updated_at #=> Time
resp.task.version #=> Integer
resp.task.primary_task_id #=> String
resp.task.status_reason #=> String
resp.task.has_linked_tasks #=> Boolean

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space containing the task

  • :task_id (required, String)

    The unique identifier of the task to retrieve

Returns:

See Also:



1384
1385
1386
1387
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1384

def get_backlog_task(params = {}, options = {})
  req = build_request(:get_backlog_task, params)
  req.send_request(options)
end

#get_operator_app(params = {}) ⇒ Types::GetOperatorAppOutput

Get the full auth configuration of operator including any enabled auth flow

Examples:

Request syntax with placeholder values


resp = client.get_operator_app({
  agent_space_id: "AgentSpaceId", # required
})

Response structure


resp.iam.operator_app_role_arn #=> String
resp.iam.created_at #=> Time
resp.iam.updated_at #=> Time
resp.idc.operator_app_role_arn #=> String
resp.idc.idc_instance_arn #=> String
resp.idc.idc_application_arn #=> String
resp.idc.created_at #=> Time
resp.idc.updated_at #=> Time
resp.idp.issuer_url #=> String
resp.idp.client_id #=> String
resp.idp.operator_app_role_arn #=> String
resp.idp.provider #=> String
resp.idp.created_at #=> Time
resp.idp.updated_at #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

Returns:

See Also:



1428
1429
1430
1431
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1428

def get_operator_app(params = {}, options = {})
  req = build_request(:get_operator_app, params)
  req.send_request(options)
end

#get_recommendation(params = {}) ⇒ Types::GetRecommendationResponse

Retrieves a specific recommendation by its ID

Examples:

Request syntax with placeholder values


resp = client.get_recommendation({
  agent_space_id: "AgentSpaceId", # required
  recommendation_id: "ResourceId", # required
  recommendation_version: 1,
})

Response structure


resp.recommendation.agent_space_arn #=> String
resp.recommendation.recommendation_id #=> String
resp.recommendation.task_id #=> String
resp.recommendation.goal_id #=> String
resp.recommendation.title #=> String
resp.recommendation.content.summary #=> String
resp.recommendation.content.spec #=> String
resp.recommendation.status #=> String, one of "PROPOSED", "ACCEPTED", "REJECTED", "CLOSED", "COMPLETED", "UPDATE_IN_PROGRESS"
resp.recommendation.priority #=> String, one of "HIGH", "MEDIUM", "LOW"
resp.recommendation.goal_version #=> Integer
resp.recommendation.additional_context #=> String
resp.recommendation.created_at #=> Time
resp.recommendation.updated_at #=> Time
resp.recommendation.version #=> Integer

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space containing the recommendation

  • :recommendation_id (required, String)

    The unique identifier for the recommendation to retrieve

  • :recommendation_version (Integer)

    Specific version of the recommendation to retrieve. If not specified, returns the latest version.

Returns:

See Also:



1479
1480
1481
1482
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1479

def get_recommendation(params = {}, options = {})
  req = build_request(:get_recommendation, params)
  req.send_request(options)
end

#get_service(params = {}) ⇒ Types::GetServiceOutput

Retrieves given service by it's unique identifier

Examples:

Request syntax with placeholder values


resp = client.get_service({
  service_id: "ServiceId", # required
})

Response structure


resp.service.service_id #=> String
resp.service.service_type #=> String, one of "github", "slack", "azure", "azuredevops", "dynatrace", "servicenow", "pagerduty", "gitlab", "eventChannel", "mcpservernewrelic", "mcpservergrafana", "mcpserverdatadog", "mcpserver", "mcpserversplunk", "azureidentity"
resp.service.name #=> String
resp.service.accessible_resources #=> Array
resp.service.additional_service_details.github.owner #=> String
resp.service.additional_service_details.github.owner_type #=> String, one of "organization", "user"
resp.service.additional_service_details.github.target_url #=> String
resp.service.additional_service_details.slack.team_id #=> String
resp.service.additional_service_details.slack.team_name #=> String
resp.service.additional_service_details.mcpserverdatadog.name #=> String
resp.service.additional_service_details.mcpserverdatadog.endpoint #=> String
resp.service.additional_service_details.mcpserverdatadog.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.service.additional_service_details.mcpserverdatadog.description #=> String
resp.service.additional_service_details.mcpserverdatadog.api_key_header #=> String
resp.service.additional_service_details.mcpserver.name #=> String
resp.service.additional_service_details.mcpserver.endpoint #=> String
resp.service.additional_service_details.mcpserver.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.service.additional_service_details.mcpserver.description #=> String
resp.service.additional_service_details.mcpserver.api_key_header #=> String
resp.service.additional_service_details.servicenow.instance_url #=> String
resp.service.additional_service_details.gitlab.target_url #=> String
resp.service.additional_service_details.gitlab.token_type #=> String, one of "personal", "group"
resp.service.additional_service_details.gitlab.group_id #=> String
resp.service.additional_service_details.mcpserversplunk.name #=> String
resp.service.additional_service_details.mcpserversplunk.endpoint #=> String
resp.service.additional_service_details.mcpserversplunk.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.service.additional_service_details.mcpserversplunk.description #=> String
resp.service.additional_service_details.mcpserversplunk.api_key_header #=> String
resp.service.additional_service_details.mcpservernewrelic. #=> String
resp.service.additional_service_details.mcpservernewrelic.region #=> String, one of "US", "EU"
resp.service.additional_service_details.mcpservernewrelic.description #=> String
resp.service.additional_service_details.azuredevops.organization_name #=> String
resp.service.additional_service_details.azureidentity.tenant_id #=> String
resp.service.additional_service_details.azureidentity.client_id #=> String
resp.service.additional_service_details.azureidentity.web_identity_role_arn #=> String
resp.service.additional_service_details.azureidentity.web_identity_token_audiences #=> Array
resp.service.additional_service_details.azureidentity.web_identity_token_audiences[0] #=> String
resp.service.additional_service_details.mcpservergrafana.endpoint #=> String
resp.service.additional_service_details.mcpservergrafana.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.service.additional_service_details.pagerduty.scopes #=> Array
resp.service.additional_service_details.pagerduty.scopes[0] #=> String
resp.service.kms_key_arn #=> String
resp.service.private_connection_name #=> String
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :service_id (required, String)

    The unique identifier of the given service.

Returns:

See Also:



1552
1553
1554
1555
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1552

def get_service(params = {}, options = {})
  req = build_request(:get_service, params)
  req.send_request(options)
end

#list_agent_spaces(params = {}) ⇒ Types::ListAgentSpacesOutput

Lists all AgentSpaces with optional pagination.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_agent_spaces({
  max_results: 1,
  next_token: "NextToken",
})

Response structure


resp.next_token #=> String
resp.agent_spaces #=> Array
resp.agent_spaces[0].name #=> String
resp.agent_spaces[0].description #=> String
resp.agent_spaces[0].locale #=> String
resp.agent_spaces[0].created_at #=> Time
resp.agent_spaces[0].updated_at #=> Time
resp.agent_spaces[0].kms_key_arn #=> String
resp.agent_spaces[0].agent_space_id #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :max_results (Integer)

    Maximum number of results to return in a single call.

  • :next_token (String)

    Token for the next page of results.

Returns:

See Also:



1595
1596
1597
1598
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1595

def list_agent_spaces(params = {}, options = {})
  req = build_request(:list_agent_spaces, params)
  req.send_request(options)
end

#list_associations(params = {}) ⇒ Types::ListAssociationsOutput

List all associations for given AgentSpace

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_associations({
  agent_space_id: "AgentSpaceId", # required
  max_results: 1,
  next_token: "NextToken",
  filter_service_types: "ListAssociationsInputFilterServiceTypesString",
})

Response structure


resp.next_token #=> String
resp.associations #=> Array
resp.associations[0].agent_space_id #=> String
resp.associations[0].created_at #=> Time
resp.associations[0].updated_at #=> Time
resp.associations[0].status #=> String, one of "valid", "invalid", "pending-confirmation"
resp.associations[0].association_id #=> String
resp.associations[0].service_id #=> String
resp.associations[0].configuration.source_aws. #=> String
resp.associations[0].configuration.source_aws. #=> String, one of "source"
resp.associations[0].configuration.source_aws.assumable_role_arn #=> String
resp.associations[0].configuration.source_aws.external_id #=> String
resp.associations[0].configuration.aws.assumable_role_arn #=> String
resp.associations[0].configuration.aws. #=> String
resp.associations[0].configuration.aws. #=> String, one of "monitor"
resp.associations[0].configuration.github.repo_name #=> String
resp.associations[0].configuration.github.repo_id #=> String
resp.associations[0].configuration.github.owner #=> String
resp.associations[0].configuration.github.owner_type #=> String, one of "organization", "user"
resp.associations[0].configuration.github.instance_identifier #=> String
resp.associations[0].configuration.slack.workspace_id #=> String
resp.associations[0].configuration.slack.workspace_name #=> String
resp.associations[0].configuration.slack.transmission_target.ops_oncall_target.channel_name #=> String
resp.associations[0].configuration.slack.transmission_target.ops_oncall_target.channel_id #=> String
resp.associations[0].configuration.slack.transmission_target.ops_sre_target.channel_name #=> String
resp.associations[0].configuration.slack.transmission_target.ops_sre_target.channel_id #=> String
resp.associations[0].configuration.dynatrace.env_id #=> String
resp.associations[0].configuration.dynatrace.resources #=> Array
resp.associations[0].configuration.dynatrace.resources[0] #=> String
resp.associations[0].configuration.servicenow.instance_id #=> String
resp.associations[0].configuration.servicenow.auth_scopes #=> Array
resp.associations[0].configuration.servicenow.auth_scopes[0] #=> String
resp.associations[0].configuration.mcpservernewrelic. #=> String
resp.associations[0].configuration.mcpservernewrelic.endpoint #=> String
resp.associations[0].configuration.gitlab.project_id #=> String
resp.associations[0].configuration.gitlab.project_path #=> String
resp.associations[0].configuration.gitlab.instance_identifier #=> String
resp.associations[0].configuration.azure.subscription_id #=> String
resp.associations[0].configuration.azuredevops.organization_name #=> String
resp.associations[0].configuration.azuredevops.project_id #=> String
resp.associations[0].configuration.azuredevops.project_name #=> String
resp.associations[0].configuration.mcpservergrafana.endpoint #=> String
resp.associations[0].configuration.mcpservergrafana.organization_id #=> String
resp.associations[0].configuration.mcpservergrafana.tools #=> Array
resp.associations[0].configuration.mcpservergrafana.tools[0] #=> String
resp.associations[0].configuration.pagerduty.services #=> Array
resp.associations[0].configuration.pagerduty.services[0] #=> String
resp.associations[0].configuration.pagerduty.customer_email #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :max_results (Integer)

    Maximum number of results to return in a single call.

  • :next_token (String)

    Token for the next page of results.

  • :filter_service_types (String)

    A comma-separated list of service types to filter list associations output

Returns:

See Also:



1686
1687
1688
1689
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1686

def list_associations(params = {}, options = {})
  req = build_request(:list_associations, params)
  req.send_request(options)
end

#list_backlog_tasks(params = {}) ⇒ Types::ListBacklogTasksResponse

Lists backlog tasks in the specified agent space with optional filtering and sorting

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_backlog_tasks({
  agent_space_id: "AgentSpaceId", # required
  filter: {
    created_after: Time.now,
    created_before: Time.now,
    priority: ["CRITICAL"], # accepts CRITICAL, HIGH, MEDIUM, LOW, MINIMAL
    status: ["PENDING_TRIAGE"], # accepts PENDING_TRIAGE, LINKED, PENDING_START, IN_PROGRESS, PENDING_CUSTOMER_APPROVAL, COMPLETED, FAILED, TIMED_OUT, CANCELED
    task_type: ["INVESTIGATION"], # accepts INVESTIGATION, EVALUATION
    primary_task_id: "ResourceId",
  },
  limit: 1,
  next_token: "NextToken",
  sort_field: "CREATED_AT", # accepts CREATED_AT, PRIORITY
  order: "ASC", # accepts ASC, DESC
})

Response structure


resp.tasks #=> Array
resp.tasks[0].agent_space_id #=> String
resp.tasks[0].task_id #=> String
resp.tasks[0].execution_id #=> String
resp.tasks[0].title #=> String
resp.tasks[0].description #=> String
resp.tasks[0].reference.system #=> String
resp.tasks[0].reference.title #=> String
resp.tasks[0].reference.reference_id #=> String
resp.tasks[0].reference.reference_url #=> String
resp.tasks[0].reference.association_id #=> String
resp.tasks[0].task_type #=> String, one of "INVESTIGATION", "EVALUATION"
resp.tasks[0].priority #=> String, one of "CRITICAL", "HIGH", "MEDIUM", "LOW", "MINIMAL"
resp.tasks[0].status #=> String, one of "PENDING_TRIAGE", "LINKED", "PENDING_START", "IN_PROGRESS", "PENDING_CUSTOMER_APPROVAL", "COMPLETED", "FAILED", "TIMED_OUT", "CANCELED"
resp.tasks[0].created_at #=> Time
resp.tasks[0].updated_at #=> Time
resp.tasks[0].version #=> Integer
resp.tasks[0].primary_task_id #=> String
resp.tasks[0].status_reason #=> String
resp.tasks[0].has_linked_tasks #=> Boolean
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space containing the tasks

  • :filter (Types::TaskFilter)

    Filter criteria to apply when listing tasks

    Filtering restrictions:

    • Each filter field list is limited to a single value
    • Filtering by Priority and Status at the same time when not filtering by Type is not permitted
    • Timestamp filters (createdAfter, createdBefore) can be combined with other filters when not sorting by priority
  • :limit (Integer)

    Maximum number of tasks to return in a single response (1-1000, default: 100)

  • :next_token (String)

    Token for retrieving the next page of results

  • :sort_field (String)

    Field to sort by

    Sorting restrictions:
    
    • Only sorting on createdAt is supported when using priority or status filters alone.
    • Sorting by priority is not supported when using Timestamp filters (createdAfter, createdBefore)
  • :order (String)

    Sort order for the tasks based on sortField (default: DESC)

Returns:

See Also:



1781
1782
1783
1784
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1781

def list_backlog_tasks(params = {}, options = {})
  req = build_request(:list_backlog_tasks, params)
  req.send_request(options)
end

#list_chats(params = {}) ⇒ Types::ListChatsResponse

Retrieves a paginated list of the user's recent chat executions

Examples:

Request syntax with placeholder values


resp = client.list_chats({
  agent_space_id: "AgentSpaceId", # required
  user_id: "ResourceId", # required
  max_results: 1,
  next_token: "String",
})

Response structure


resp.executions #=> Array
resp.executions[0].execution_id #=> String
resp.executions[0].created_at #=> Time
resp.executions[0].updated_at #=> Time
resp.executions[0].summary #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    Unique identifier for an agent space (allows alphanumeric characters and hyphens; 1-64 characters)

  • :user_id (required, String)

    The user identifier to list chats for

  • :max_results (Integer)

    Maximum number of results to return

  • :next_token (String)

    Token for pagination

Returns:

See Also:



1828
1829
1830
1831
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1828

def list_chats(params = {}, options = {})
  req = build_request(:list_chats, params)
  req.send_request(options)
end

#list_executions(params = {}) ⇒ Types::ListExecutionsResponse

List executions

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_executions({
  agent_space_id: "AgentSpaceId", # required
  task_id: "ResourceId", # required
  limit: 1,
  next_token: "NextToken",
})

Response structure


resp.executions #=> Array
resp.executions[0].agent_space_id #=> String
resp.executions[0].execution_id #=> String
resp.executions[0].parent_execution_id #=> String
resp.executions[0].agent_sub_task #=> String
resp.executions[0].created_at #=> Time
resp.executions[0].updated_at #=> Time
resp.executions[0].execution_status #=> String, one of "FAILED", "RUNNING", "STOPPED", "CANCELED", "TIMED_OUT"
resp.executions[0].agent_type #=> String
resp.executions[0].uid #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space

  • :task_id (required, String)

    The unique identifier of the task whose executions to retrieve

  • :limit (Integer)

    Maximum number of executions to return

  • :next_token (String)

    Token for pagination to retrieve the next set of results

Returns:

See Also:



1881
1882
1883
1884
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1881

def list_executions(params = {}, options = {})
  req = build_request(:list_executions, params)
  req.send_request(options)
end

#list_goals(params = {}) ⇒ Types::ListGoalsResponse

Lists goals in the specified agent space with optional filtering

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_goals({
  agent_space_id: "AgentSpaceId", # required
  status: "ACTIVE", # accepts ACTIVE, PAUSED, COMPLETE
  goal_type: "CUSTOMER_DEFINED", # accepts CUSTOMER_DEFINED, ONCALL_REPORT
  limit: 1,
  next_token: "NextToken",
})

Response structure


resp.goals #=> Array
resp.goals[0].agent_space_arn #=> String
resp.goals[0].goal_id #=> String
resp.goals[0].title #=> String
resp.goals[0].content.description #=> String
resp.goals[0].content.objectives #=> String
resp.goals[0].status #=> String, one of "ACTIVE", "PAUSED", "COMPLETE"
resp.goals[0].goal_type #=> String, one of "CUSTOMER_DEFINED", "ONCALL_REPORT"
resp.goals[0].created_at #=> Time
resp.goals[0].updated_at #=> Time
resp.goals[0].last_evaluated_at #=> Time
resp.goals[0].last_task_id #=> String
resp.goals[0].last_successful_task_id #=> String
resp.goals[0].version #=> Integer
resp.goals[0].evaluation_schedule.state #=> String, one of "ENABLED", "DISABLED"
resp.goals[0].evaluation_schedule.expression #=> String
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space

  • :status (String)

    Filter goals by goal status

  • :goal_type (String)

    Filter goals by goal type

  • :limit (Integer)

    Maximum number of goals to return

  • :next_token (String)

    Pagination token for the next set of results

Returns:

See Also:



1944
1945
1946
1947
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 1944

def list_goals(params = {}, options = {})
  req = build_request(:list_goals, params)
  req.send_request(options)
end

#list_journal_records(params = {}) ⇒ Types::ListJournalRecordsResponse

List journal records for a specific execution

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_journal_records({
  agent_space_id: "AgentSpaceId", # required
  execution_id: "ResourceId", # required
  limit: 1,
  next_token: "NextToken",
  record_type: "String",
  order: "ASC", # accepts ASC, DESC
})

Response structure


resp.records #=> Array
resp.records[0].agent_space_id #=> String
resp.records[0].execution_id #=> String
resp.records[0].record_id #=> String
resp.records[0].created_at #=> Time
resp.records[0].record_type #=> String
resp.records[0].user_reference.user_id #=> String
resp.records[0].user_reference.user_type #=> String, one of "IAM", "IDC", "IDP"
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space containing the execution

  • :execution_id (required, String)

    The unique identifier of the execution whose journal records to retrieve

  • :limit (Integer)

    Maximum number of records to return in a single response (1-100, default: 100)

  • :next_token (String)

    Token for retrieving the next page of results

  • :record_type (String)

    Filter records by type (empty string returns all types)

  • :order (String)

    Sort order for the records based on timestamp (default: DESC)

Returns:

See Also:



2005
2006
2007
2008
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2005

def list_journal_records(params = {}, options = {})
  req = build_request(:list_journal_records, params)
  req.send_request(options)
end

#list_pending_messages(params = {}) ⇒ Types::ListPendingMessagesResponse

List pending messages for a specific execution.

Examples:

Request syntax with placeholder values


resp = client.list_pending_messages({
  agent_space_id: "AgentSpaceId", # required
  execution_id: "ResourceId", # required
})

Response structure


resp.agent_space_id #=> String
resp.execution_id #=> String
resp.messages #=> Array
resp.messages[0].message_id #=> String
resp.messages[0].message.user_message #=> Array
resp.messages[0].message.user_message[0].text #=> String
resp.messages[0].message.assistant_message #=> Array
resp.messages[0].message.assistant_message[0].text #=> String
resp.created_at #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    Unique identifier for an agent space (allows alphanumeric characters and hyphens; 1-64 characters)

  • :execution_id (required, String)

    The unique identifier of the execution whose journal records to retrieve

Returns:

See Also:



2050
2051
2052
2053
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2050

def list_pending_messages(params = {}, options = {})
  req = build_request(:list_pending_messages, params)
  req.send_request(options)
end

#list_private_connections(params = {}) ⇒ Types::ListPrivateConnectionsOutput

Lists all Private Connections in the caller's account.

Examples:

Response structure


resp.private_connections #=> Array
resp.private_connections[0].name #=> String
resp.private_connections[0].type #=> String, one of "SELF_MANAGED", "SERVICE_MANAGED"
resp.private_connections[0].resource_gateway_id #=> String
resp.private_connections[0].host_address #=> String
resp.private_connections[0].vpc_id #=> String
resp.private_connections[0].resource_configuration_id #=> String
resp.private_connections[0].status #=> String, one of "ACTIVE", "CREATE_IN_PROGRESS", "CREATE_FAILED", "DELETE_IN_PROGRESS", "DELETE_FAILED"
resp.private_connections[0].certificate_expiry_time #=> Time

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Returns:

See Also:



2077
2078
2079
2080
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2077

def list_private_connections(params = {}, options = {})
  req = build_request(:list_private_connections, params)
  req.send_request(options)
end

#list_recommendations(params = {}) ⇒ Types::ListRecommendationsResponse

Lists recommendations for the specified agent space

Examples:

Request syntax with placeholder values


resp = client.list_recommendations({
  agent_space_id: "AgentSpaceId", # required
  task_id: "ResourceId",
  goal_id: "ResourceId",
  status: "PROPOSED", # accepts PROPOSED, ACCEPTED, REJECTED, CLOSED, COMPLETED, UPDATE_IN_PROGRESS
  priority: "HIGH", # accepts HIGH, MEDIUM, LOW
  limit: 1,
  next_token: "NextToken",
})

Response structure


resp.recommendations #=> Array
resp.recommendations[0].agent_space_arn #=> String
resp.recommendations[0].recommendation_id #=> String
resp.recommendations[0].task_id #=> String
resp.recommendations[0].goal_id #=> String
resp.recommendations[0].title #=> String
resp.recommendations[0].content.summary #=> String
resp.recommendations[0].content.spec #=> String
resp.recommendations[0].status #=> String, one of "PROPOSED", "ACCEPTED", "REJECTED", "CLOSED", "COMPLETED", "UPDATE_IN_PROGRESS"
resp.recommendations[0].priority #=> String, one of "HIGH", "MEDIUM", "LOW"
resp.recommendations[0].goal_version #=> Integer
resp.recommendations[0].additional_context #=> String
resp.recommendations[0].created_at #=> Time
resp.recommendations[0].updated_at #=> Time
resp.recommendations[0].version #=> Integer
resp.next_token #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier for the agent space containing the recommendations

  • :task_id (String)

    Optional task ID to filter recommendations by specific task

  • :goal_id (String)

    Optional goal ID to filter recommendations by specific goal

  • :status (String)

    Optional status to filter recommendations by their current status

  • :priority (String)

    Optional priority to filter recommendations by priority level

  • :limit (Integer)

    Maximum number of recommendations to return in a single response

  • :next_token (String)

    Token for retrieving the next page of results

Returns:

See Also:



2146
2147
2148
2149
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2146

def list_recommendations(params = {}, options = {})
  req = build_request(:list_recommendations, params)
  req.send_request(options)
end

#list_services(params = {}) ⇒ Types::ListServicesOutput

List a list of registered service on the account level.

The returned response is a pageable response and is Enumerable. For details on usage see PageableResponse.

Examples:

Request syntax with placeholder values


resp = client.list_services({
  max_results: 1,
  next_token: "NextToken",
  filter_service_type: "github", # accepts github, slack, azure, azuredevops, dynatrace, servicenow, pagerduty, gitlab, eventChannel, mcpservernewrelic, mcpservergrafana, mcpserverdatadog, mcpserver, mcpserversplunk, azureidentity
})

Response structure


resp.next_token #=> String
resp.services #=> Array
resp.services[0].service_id #=> String
resp.services[0].service_type #=> String, one of "github", "slack", "azure", "azuredevops", "dynatrace", "servicenow", "pagerduty", "gitlab", "eventChannel", "mcpservernewrelic", "mcpservergrafana", "mcpserverdatadog", "mcpserver", "mcpserversplunk", "azureidentity"
resp.services[0].name #=> String
resp.services[0].accessible_resources #=> Array
resp.services[0].additional_service_details.github.owner #=> String
resp.services[0].additional_service_details.github.owner_type #=> String, one of "organization", "user"
resp.services[0].additional_service_details.github.target_url #=> String
resp.services[0].additional_service_details.slack.team_id #=> String
resp.services[0].additional_service_details.slack.team_name #=> String
resp.services[0].additional_service_details.mcpserverdatadog.name #=> String
resp.services[0].additional_service_details.mcpserverdatadog.endpoint #=> String
resp.services[0].additional_service_details.mcpserverdatadog.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.services[0].additional_service_details.mcpserverdatadog.description #=> String
resp.services[0].additional_service_details.mcpserverdatadog.api_key_header #=> String
resp.services[0].additional_service_details.mcpserver.name #=> String
resp.services[0].additional_service_details.mcpserver.endpoint #=> String
resp.services[0].additional_service_details.mcpserver.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.services[0].additional_service_details.mcpserver.description #=> String
resp.services[0].additional_service_details.mcpserver.api_key_header #=> String
resp.services[0].additional_service_details.servicenow.instance_url #=> String
resp.services[0].additional_service_details.gitlab.target_url #=> String
resp.services[0].additional_service_details.gitlab.token_type #=> String, one of "personal", "group"
resp.services[0].additional_service_details.gitlab.group_id #=> String
resp.services[0].additional_service_details.mcpserversplunk.name #=> String
resp.services[0].additional_service_details.mcpserversplunk.endpoint #=> String
resp.services[0].additional_service_details.mcpserversplunk.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.services[0].additional_service_details.mcpserversplunk.description #=> String
resp.services[0].additional_service_details.mcpserversplunk.api_key_header #=> String
resp.services[0].additional_service_details.mcpservernewrelic. #=> String
resp.services[0].additional_service_details.mcpservernewrelic.region #=> String, one of "US", "EU"
resp.services[0].additional_service_details.mcpservernewrelic.description #=> String
resp.services[0].additional_service_details.azuredevops.organization_name #=> String
resp.services[0].additional_service_details.azureidentity.tenant_id #=> String
resp.services[0].additional_service_details.azureidentity.client_id #=> String
resp.services[0].additional_service_details.azureidentity.web_identity_role_arn #=> String
resp.services[0].additional_service_details.azureidentity.web_identity_token_audiences #=> Array
resp.services[0].additional_service_details.azureidentity.web_identity_token_audiences[0] #=> String
resp.services[0].additional_service_details.mcpservergrafana.endpoint #=> String
resp.services[0].additional_service_details.mcpservergrafana.authorization_method #=> String, one of "oauth-client-credentials", "oauth-3lo", "api-key", "bearer-token"
resp.services[0].additional_service_details.pagerduty.scopes #=> Array
resp.services[0].additional_service_details.pagerduty.scopes[0] #=> String
resp.services[0].kms_key_arn #=> String
resp.services[0].private_connection_name #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :max_results (Integer)

    Maximum number of results to return in a single call.

  • :next_token (String)

    Token for the next page of results.

  • :filter_service_type (String)

    Optional filter to list only services of a specific type.

Returns:

See Also:



2229
2230
2231
2232
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2229

def list_services(params = {}, options = {})
  req = build_request(:list_services, params)
  req.send_request(options)
end

#list_tags_for_resource(params = {}) ⇒ Types::ListTagsForResourceResponse

Lists tags for the specified AWS DevOps Agent resource.

Examples:

Request syntax with placeholder values


resp = client.list_tags_for_resource({
  resource_arn: "ListTagsForResourceRequestResourceArnString", # required
})

Response structure


resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :resource_arn (required, String)

    The ARN of the resource.

Returns:

See Also:



2258
2259
2260
2261
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2258

def list_tags_for_resource(params = {}, options = {})
  req = build_request(:list_tags_for_resource, params)
  req.send_request(options)
end

#list_webhooks(params = {}) ⇒ Types::ListWebhooksOutput

List all webhooks for given Association

Examples:

Request syntax with placeholder values


resp = client.list_webhooks({
  agent_space_id: "AgentSpaceId", # required
  association_id: "AssociationId", # required
})

Response structure


resp.webhooks #=> Array
resp.webhooks[0].webhook_url #=> String
resp.webhooks[0].webhook_type #=> String, one of "hmac", "apikey", "gitlab", "pagerduty"
resp.webhooks[0].webhook_id #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :agent_space_id (required, String)

    The unique identifier of the AgentSpace

  • :association_id (required, String)

    The unique identifier of the given association.

Returns:

See Also:



2293
2294
2295
2296
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2293

def list_webhooks(params = {}, options = {})
  req = build_request(:list_webhooks, params)
  req.send_request(options)
end

#register_service(params = {}) ⇒ Types::RegisterServiceOutput

This operation registers the specified service

Examples:

Request syntax with placeholder values


resp = client.register_service({
  service: "dynatrace", # required, accepts dynatrace, servicenow, pagerduty, gitlab, eventChannel, mcpservernewrelic, mcpservergrafana, mcpserverdatadog, mcpserver, mcpserversplunk, azureidentity
  service_details: { # required
    dynatrace: {
      account_urn: "DynatraceServiceDetailsAccountUrnString", # required
      authorization_config: {
        o_auth_client_credentials: {
          client_name: "DynatraceOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
        },
      },
    },
    servicenow: {
      instance_url: "ServiceNowInstanceUrl", # required
      authorization_config: {
        o_auth_client_credentials: {
          client_name: "ServiceNowOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
        },
      },
    },
    mcpserverdatadog: {
      name: "DatadogServiceDetailsNameString", # required
      endpoint: "DatadogServiceDetailsEndpointString", # required
      description: "DatadogServiceDetailsDescriptionString",
      authorization_config: { # required
        authorization_discovery: {
          return_to_endpoint: "MCPServerAuthorizationDiscoveryConfigReturnToEndpointString", # required
        },
      },
    },
    mcpserver: {
      name: "MCPServerDetailsNameString", # required
      endpoint: "MCPServerDetailsEndpointString", # required
      description: "MCPServerDetailsDescriptionString",
      authorization_config: { # required
        o_auth_client_credentials: {
          client_name: "MCPServerOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
          exchange_url: "MCPServerOAuthClientCredentialsConfigExchangeUrlString", # required
          scopes: ["String"],
        },
        o_auth_3_lo: {
          client_name: "MCPServerOAuth3LOConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          return_to_endpoint: "MCPServerOAuth3LOConfigReturnToEndpointString", # required
          authorization_url: "MCPServerOAuth3LOConfigAuthorizationUrlString", # required
          exchange_url: "MCPServerOAuth3LOConfigExchangeUrlString", # required
          client_secret: "ClientSecret",
          support_code_challenge: false,
          scopes: ["String"],
        },
        api_key: {
          api_key_name: "MCPServerAPIKeyConfigApiKeyNameString", # required
          api_key_value: "MCPServerAPIKeyConfigApiKeyValueString", # required
          api_key_header: "MCPServerAPIKeyConfigApiKeyHeaderString", # required
        },
        bearer_token: {
          token_name: "MCPServerBearerTokenConfigTokenNameString", # required
          token_value: "MCPServerBearerTokenConfigTokenValueString", # required
          authorization_header: "MCPServerBearerTokenConfigAuthorizationHeaderString",
        },
        authorization_discovery: {
          return_to_endpoint: "MCPServerAuthorizationDiscoveryConfigReturnToEndpointString", # required
        },
      },
    },
    gitlab: {
      target_url: "GitLabDetailsTargetUrlString", # required
      token_type: "personal", # required, accepts personal, group
      token_value: "GitLabDetailsTokenValueString", # required
      group_id: "String",
    },
    mcpserversplunk: {
      name: "MCPServerDetailsNameString", # required
      endpoint: "MCPServerDetailsEndpointString", # required
      description: "MCPServerDetailsDescriptionString",
      authorization_config: { # required
        o_auth_client_credentials: {
          client_name: "MCPServerOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
          exchange_url: "MCPServerOAuthClientCredentialsConfigExchangeUrlString", # required
          scopes: ["String"],
        },
        o_auth_3_lo: {
          client_name: "MCPServerOAuth3LOConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          return_to_endpoint: "MCPServerOAuth3LOConfigReturnToEndpointString", # required
          authorization_url: "MCPServerOAuth3LOConfigAuthorizationUrlString", # required
          exchange_url: "MCPServerOAuth3LOConfigExchangeUrlString", # required
          client_secret: "ClientSecret",
          support_code_challenge: false,
          scopes: ["String"],
        },
        api_key: {
          api_key_name: "MCPServerAPIKeyConfigApiKeyNameString", # required
          api_key_value: "MCPServerAPIKeyConfigApiKeyValueString", # required
          api_key_header: "MCPServerAPIKeyConfigApiKeyHeaderString", # required
        },
        bearer_token: {
          token_name: "MCPServerBearerTokenConfigTokenNameString", # required
          token_value: "MCPServerBearerTokenConfigTokenValueString", # required
          authorization_header: "MCPServerBearerTokenConfigAuthorizationHeaderString",
        },
        authorization_discovery: {
          return_to_endpoint: "MCPServerAuthorizationDiscoveryConfigReturnToEndpointString", # required
        },
      },
    },
    mcpservernewrelic: {
      authorization_config: { # required
        api_key: {
          api_key: "NewRelicApiKeyConfigApiKeyString", # required
          account_id: "NewRelicApiKeyConfigAccountIdString", # required
          region: "US", # required, accepts US, EU
          application_ids: ["NewRelicApplicationIdsMemberString"],
          entity_guids: ["NewRelicEntityGuidsMemberString"],
          alert_policy_ids: ["NewRelicAlertPolicyIdsMemberString"],
        },
      },
    },
    event_channel: {
      type: "webhook", # accepts webhook
    },
    mcpservergrafana: {
      name: "GrafanaServiceDetailsNameString", # required
      endpoint: "GrafanaServiceDetailsEndpointString", # required
      description: "GrafanaServiceDetailsDescriptionString",
      authorization_config: { # required
        o_auth_client_credentials: {
          client_name: "MCPServerOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
          exchange_url: "MCPServerOAuthClientCredentialsConfigExchangeUrlString", # required
          scopes: ["String"],
        },
        o_auth_3_lo: {
          client_name: "MCPServerOAuth3LOConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          return_to_endpoint: "MCPServerOAuth3LOConfigReturnToEndpointString", # required
          authorization_url: "MCPServerOAuth3LOConfigAuthorizationUrlString", # required
          exchange_url: "MCPServerOAuth3LOConfigExchangeUrlString", # required
          client_secret: "ClientSecret",
          support_code_challenge: false,
          scopes: ["String"],
        },
        api_key: {
          api_key_name: "MCPServerAPIKeyConfigApiKeyNameString", # required
          api_key_value: "MCPServerAPIKeyConfigApiKeyValueString", # required
          api_key_header: "MCPServerAPIKeyConfigApiKeyHeaderString", # required
        },
        bearer_token: {
          token_name: "MCPServerBearerTokenConfigTokenNameString", # required
          token_value: "MCPServerBearerTokenConfigTokenValueString", # required
          authorization_header: "MCPServerBearerTokenConfigAuthorizationHeaderString",
        },
        authorization_discovery: {
          return_to_endpoint: "MCPServerAuthorizationDiscoveryConfigReturnToEndpointString", # required
        },
      },
    },
    pagerduty: {
      scopes: ["String"], # required
      authorization_config: { # required
        o_auth_client_credentials: {
          client_name: "PagerDutyOAuthClientCredentialsConfigClientNameString",
          client_id: "ClientId", # required
          exchange_parameters: {
            "String" => "ExchangeParameterValue",
          },
          client_secret: "ClientSecret", # required
        },
      },
    },
    azureidentity: {
      tenant_id: "Guid", # required
      client_id: "Guid", # required
      web_identity_role_arn: "RoleArn", # required
      web_identity_token_audiences: ["String"], # required
    },
  },
  kms_key_arn: "KmsKeyArn",
  private_connection_name: "PrivateConnectionName",
  name: "ServiceName",
  tags: {
    "TagKey" => "TagValue",
  },
})

Response structure


resp.service_id #=> String
resp.additional_step.oauth.authorization_url #=> String
resp.kms_key_arn #=> String
resp.tags #=> Hash
resp.tags["TagKey"] #=> String

Parameters:

  • params (Hash) (defaults to: {})

    ({})

Options Hash (params):

  • :service (required, String)

    Services that can be registered via the post-registration API (excludes OAuth 3LO services).

  • :service_details (required, Types::ServiceDetails)

    Service-specific authorization configuration parameters

  • :kms_key_arn (String)

    The ARN of the AWS Key Management Service (AWS KMS) customer managed key that's used to encrypt resources.

  • :private_connection_name (String)

    The name of the private connection to use for VPC connectivity.

  • :name (String)

    The display name for the service registration.

  • :tags (Hash<String,String>)

    Tags to add to the Service at registration time.

Returns:

See Also:



2558
2559
2560
2561
# File 'gems/aws-sdk-devopsagent/lib/aws-sdk-devopsagent/client.rb', line 2558

def register_service(params = {}, options = {})
  req = build_request(:register_service, params)
  req.send_request(options)
end

#send_message(params = {}) ⇒ Types::SendMessageResponse

Sends a chat message and streams the response for the specified agent space execution

Examples:

EventStream Operation Example


# You can process the event once it arrives immediately, or wait until the
# full response is complete and iterate through the eventstream enumerator.

# To interact with event immediately, you need to register send_message
# with callbacks. Callbacks can be registered for specific events or for all
# events, including error events.

# Callbacks can be passed into the `:event_stream_handler` option or within a
# block statement attached to the #send_message call directly. Hybrid
# pattern of both is also supported.

# `:event_stream_handler` option takes in either a Proc object or
# Aws::DevOpsAgent::EventStreams::SendMessageEvents object.

# Usage pattern a): Callbacks with a block attached to #send_message
# Example for registering callbacks for all event types and an error event
client.send_message(
  # params input
) do |stream|
  stream.on_error_event do |event|
    # catch unmodeled error event in the stream
    raise event
    # => Aws::Errors::EventError
    # event.event_type => :error
    # event.error_code => String
    # event.error_message => String
  end

  stream.on_event do |event|
    # process all events arrive
    puts event.event_type
    # ...
  end
end

# Usage pattern b): Pass in `:event_stream_handler` for #send_message
#  1) Create a Aws::DevOpsAgent::EventStreams::SendMessageEvents object
#  Example for registering callbacks with specific events

handler = Aws::DevOpsAgent::EventStreams::SendMessageEvents.new
handler.on_response_created_event do |event|
  event # => Aws::DevOpsAgent::Types::responseCreated
end
handler.on_response_in_progress_event do |event|
  event # => Aws::DevOpsAgent::Types::responseInProgress
end
handler.on_response_completed_event do |event|
  event # => Aws::DevOpsAgent::Types::responseCompleted
end
handler.on_response_failed_event do |event|
  event # => Aws::DevOpsAgent::Types::responseFailed
end
handler.on_summary_event do |event|
  event # => Aws::DevOpsAgent::Types::summary
end
handler.on_heartbeat_event do |event|
  event # => Aws::DevOpsAgent::Types::heartbeat
end
handler.on_content_block_start_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockStart
end
handler.on_content_block_delta_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockDelta
end
handler.on_content_block_stop_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockStop
end

client.send_message(
  # params inputs
  event_stream_handler: handler
)

#  2) Use a Ruby Proc object
#  Example for registering callbacks with specific events
handler = Proc.new do |stream|
  stream.on_response_created_event do |event|
    event # => Aws::DevOpsAgent::Types::responseCreated
  end
  stream.on_response_in_progress_event do |event|
    event # => Aws::DevOpsAgent::Types::responseInProgress
  end
  stream.on_response_completed_event do |event|
    event # => Aws::DevOpsAgent::Types::responseCompleted
  end
  stream.on_response_failed_event do |event|
    event # => Aws::DevOpsAgent::Types::responseFailed
  end
  stream.on_summary_event do |event|
    event # => Aws::DevOpsAgent::Types::summary
  end
  stream.on_heartbeat_event do |event|
    event # => Aws::DevOpsAgent::Types::heartbeat
  end
  stream.on_content_block_start_event do |event|
    event # => Aws::DevOpsAgent::Types::contentBlockStart
  end
  stream.on_content_block_delta_event do |event|
    event # => Aws::DevOpsAgent::Types::contentBlockDelta
  end
  stream.on_content_block_stop_event do |event|
    event # => Aws::DevOpsAgent::Types::contentBlockStop
  end
end

client.send_message(
  # params inputs
  event_stream_handler: handler
)

#  Usage pattern c): Hybrid pattern of a) and b)
handler = Aws::DevOpsAgent::EventStreams::SendMessageEvents.new
handler.on_response_created_event do |event|
  event # => Aws::DevOpsAgent::Types::responseCreated
end
handler.on_response_in_progress_event do |event|
  event # => Aws::DevOpsAgent::Types::responseInProgress
end
handler.on_response_completed_event do |event|
  event # => Aws::DevOpsAgent::Types::responseCompleted
end
handler.on_response_failed_event do |event|
  event # => Aws::DevOpsAgent::Types::responseFailed
end
handler.on_summary_event do |event|
  event # => Aws::DevOpsAgent::Types::summary
end
handler.on_heartbeat_event do |event|
  event # => Aws::DevOpsAgent::Types::heartbeat
end
handler.on_content_block_start_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockStart
end
handler.on_content_block_delta_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockDelta
end
handler.on_content_block_stop_event do |event|
  event # => Aws::DevOpsAgent::Types::contentBlockStop
end

client.send_message(
  # params input
  event_stream_handler: handler
) do |stream|
  stream.on_error_event do |event|
    # catch unmodeled error event in the stream
    raise event
    # => Aws::Errors::EventError
    # event.event_type => :error
    # event.error_code => String
    # event.error_message => String
  end
end

# You can also iterate through events after the response complete.
# Events are available at
resp.events # => Enumerator
# For parameter input example, please refer to following request syntax.

Request syntax with placeholder values


resp = client.send_message({
  agent_space_id: "AgentSpaceId", # required
  execution_id: "ResourceId", # required
  content: "MessageContent", # required
  context: {
    current_page: "String",
    last_message: "String",
    user_action_response: "String",
  },
  user_id: "ResourceId", # required
})

Response structure


# All events are available at resp.events:
resp.events #=> Enumerator
resp.events.event_types #=> [:response_created, :response_in_progress, :response_completed, :response_failed, :summary, :heartbeat, :content_block_start, :content_block_delta, :content_block_stop]

# For :response_created event available at #on_response_created_event callback and response eventstream enumerator:
event.response_id #=> String
event.sequence_number #=> Integer

# For :response_in_progress event available at #on_response_in_progress_event callback and response eventstream enumerator:
event.response_id #=> String
event.sequence_number #=> Integer

# For :response_completed event available at #on_response_completed_event callback and response eventstream enumerator:
event.response_id #=> String
event.usage.input_tokens #=> Integer
event.usage.output_tokens #=> Integer
event.usage.total_tokens #=> Integer
event.sequence_number #=> Integer

# For :response_failed event available at #on_response_failed_event callback and response eventstream enumerator:
event.response_id #=> String
event.error_code #=> String
[...]
